# vim: set fileencoding=euc-jp ts=4 sw=4 sts=0 formatoptions= :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from Tkinter import *
from ZFrame import ZFrame
from board9.CntlSpace import CMakeSpace, VCMakeSpace

class ZShogiMake(ZFrame):
	def __init__(self, master, diag='', hist='', side='1', size=0):
		self.diag = diag
		self.hist = hist
		self.side = side
		ZFrame.__init__(self, master, diag, size)
		self.diagPanel.set(self.diag)

	def getListBox(self, frame):
		panel = Frame(frame, bd=1)
		scrollbar = Scrollbar(panel, orient=VERTICAL)
		self.listbox = Listbox(panel, bd=1, width=10, height=11,
			yscrollcommand=scrollbar.set)
		scrollbar.config(command=self.listbox.yview)
		self.listbox.pack(side=LEFT, fill=BOTH, expand=1)
		scrollbar.pack(side=LEFT, fill=Y)
		self.listbox.insert(END, self.hist.split(','))
		return panel

	def selected(self, id=0):
		pass

	def controlBox(self, frame):
		bt = Button(frame, text=u'Quit', bd=1, command=self.quit)
		bt.pack(side=LEFT)
		bt = Button(frame, text=u'Undo', bd=1, command=self.__undo)
		bt.pack(side=LEFT)
		bt = Button(frame, text=u'Promote', bd=1, command=self.__promote)
		bt.pack(side=LEFT)
		self.bt_promote = bt

	def proc(self, pos, id):
		""" method to provide event processing """
		if self.pick and id == 0:
			space = VCMakeSpace(self.diag, self.hist, size=self.size)
			dst = space.getposFromCoord(pos)
			space.move(dst, self.pick)
			self.diag = space.getDiagram()
			self.hist = space.getScripts()
			self.pick = None
		else:
			space = VCMakeSpace(self.diag, size=self.size)
			self.pick = space.pickupTarget(pos, id)
		self.showImage()

	def __promote(self):
		space = CMakeSpace(self.diag, self.hist)
		space.promote()
		self.hist = space.getScripts()
		self.diag = space.getDiagram()
		self.showImage()

	def __undo(self):
		if self.pick:
			self.pick = None
		else:
			space = CMakeSpace(self.diag, self.hist)
			space.undo()
			self.hist = space.getScripts()
			self.diag = space.getDiagram()
		self.showImage()

	def showImage(self):
		ZFrame.showImage(self)
		self.bt_promote['state'] = 'disabled'
		if self.pick:
			self.message.set(self.pick)
		elif self.hist:
			self.bt_promote['state'] = 'active'
		self.diagPanel.set(self.diag)
		self.__showHistory()

	def __showHistory(self):
		self.listbox.delete(0, END)
		if self.hist:
			hist = self.hist.split(',')
			bw = self.side;
			for s in hist:
				self.listbox.insert(END, bw + ':' + s)
				if bw == '1':
					bw = '2' 
				else:
					bw = '1' 
			self.listbox.select_set(len(hist) - 1)

